import os
#from metaspect import AlterObject

class AlterObject:
	
	def __init__(self, filepath ): #filepath=""):
		"""docstring for __init__"""
		if len( filepath ) == 0:
			self.file = None
			pass
		
		self.path = filepath
		if os.path.isfile( filepath ):
			print( "loading persistens alterations.." )
			self.file = open( self.path )
			self._loadAlterations()
		else:
			print( "creating parsistent alterations file" )
			self.file = open( self.path, "w" )
	
	def _loadAlterations(self):
		"""docstring for _loadAlterations"""
		
		self.file.seek(0)
		print( self.file.name )
		massiveExec = self.file.read().split("\n***newExecStr***\n")
		for s in massiveExec[1:]:
			print( "CODE:\n" + s + "\n" )
			exec( s )
	
	def _writeAlterations( self, data ):
		# if self.file.closed:
		# 	self.file = open( self.path, "w+" )		
		print( "*** writing data:\n" + data + "\n***\n")
		self.file.write( "\n***newExecStr***\n" + data )
	
	def replaceClassMethod(self, classRef, oldMethod, methodBody, *methodArgs):
		if hasattr(classRef, "__name__"):
			# classRef is a pointer to a class
			className = getattr(classRef, "__name__")			
		else:
			# classRef is a pointer to a class-instance/object
			className = classRef.__class__.__name__

		if not hasattr( classRef, oldMethod ):
			raise NameError( "replaceClassMethod: "+ className+" has no method "+oldMethod )
		
		if ( methodArgs[0] == "self" ):
			args = ", ".join( methodArgs )
		else:
			args = "self, " + ", ".join( methodArgs )
		
		execstr = "def %s(%s):\n\t%s\n" % (oldMethod, args, methodBody)
		execstr += "setattr(%s, \'%s\', %s)" % (className, oldMethod, oldMethod)
		
		print( "\nreplaceClassMethod:\n" + "-"*30 + "\n" + execstr + "\n" + "-"*30)

		exec( execstr )		
		if self.file.mode == "w":
			self._writeAlterations( execstr )
		
	def addClassMethod(self, classRef, newMethod, methodBody, *methodArgs):
		# class or instance
		if hasattr(classRef, "__name__"):
			# classRef is a pointer to a class
			className = getattr(classRef, "__name__")			
		else:
			# classRef is a pointer to a class-instance/object
			className = classRef.__class__.__name__
			
		if hasattr( classRef, newMethod ):
			raise NameError( "addClassMethod: "+ className+ " already has method "+newMethod )
		
		# make sure the 'self' argument is always the first
		if ( methodArgs[0] == "self" ):
			args = ", ".join( methodArgs )
		else:
			args = "self, " + ", ".join( methodArgs )
		
		# create the string to be executed
		execstr = "def %s(%s):\n\t%s\n" % (newMethod, args, methodBody)
		execstr += "setattr(%s, \'%s\', %s)" % (className, newMethod, newMethod)

		print( "\nAddClassMethod:\n" + "-"*30 + "\n" + execstr + "\n" + "-"*30)
		exec( execstr )
		if self.file.mode == "w":
			self._writeAlterations( execstr )
			
	def extendClassMethod( self, classRef, oldMethod, methodBody, *methodArgs):
		
		# determine if classRef is a class or instance of a class
		if hasattr(classRef, "__name__"):
			# class
			className = getattr(classRef, "__name__")			
		else:
			# class-instance
			className = classRef.__class__.__name__
		
		# is there a function to extend?
		if not hasattr( classRef, oldMethod ):
			raise NameError ("extendClassMethod: \'" + className +"\' has no method: " +oldMethod)
		
		# determine a "safe" name for the replaced function
		i = 0		
		while hasattr( classRef, oldMethod + "_old" + i.__str__() ):
			i += 1
		
		oldref =  oldMethod + "_old" + i.__str__()
		
		execstr = "setattr( %s, \'%s\', getattr( %s, \'%s\' ) )\n" % ( className, oldref, className, oldMethod )
		print( execstr )
		# add the oldMethod under new name
		setattr( classRef, oldref, getattr( classRef, oldMethod ) )
		
		if ( methodArgs[0] == "self" ):
			args = ", ".join( methodArgs )
		else:
			args = "self, " + ", ".join( methodArgs )
		
		# print( "**Args: ", args )
		
		# search the methodBody for the string "__oldRef()__"
		body = methodBody.replace( "__oldRef()__", "self." + oldref + "(%s)\n" % args[5:])
		print( "***********\n", body )
		
		execstr += "def %s(%s):\n\t%s\n" % (oldMethod, args, body)
		execstr += "setattr(%s, \'%s\', %s)" % (className, oldMethod, oldMethod)
		
		# print( "\nextendClassMethod:\n" + "-"*30 + "\n" + execstr + "\n" + "-"*30)
		exec( execstr )
		if self.file.mode == "w":
			self._writeAlterations( execstr )

class bleh:
	def __init__(self):
		"""docstring for __init__"""
		print( "1: Original Init!" )


t = AlterObject( "/Users/fjabbe/Documents/uni/DM8XX - Advanced Topics in Programming Languages/project/final.txt" )

s = bleh()